/*---------------------------------------------------------------*/
/* dec_to_bin: converts decimal to array of n bits in binary encoding*/
/*---------------------------------------------------------------*/
void dec_to_bin( unsigned int dval, int *bits, int n, int order )
{
    int i;
    unsigned int mask;

    for (i=0;i<n;i++)
      {
         if (!order) mask = 1<<i;
         else mask = 1<<(n-i-1);
         bits[i] = (dval&mask)!=0;
       }
    return;
}

/*---------------------------------------------------------------*/
/* dec_to_gray: converts decimal to array of n bits in gray encoding*/
/*---------------------------------------------------------------*/
void dec_to_gray( unsigned int dval, int *bits, int n, int order )
{
    int i,j;
    unsigned int mask1,mask2=0;

    for (i=0;i<n;i++)
      {
         mask1 = 1<<(n-1-i);
         if (order) j = i;
         else j = n-i-1;
         bits[j] = (0!=(dval&mask1))^(0!=(dval&mask2));
         mask2 = mask1;
       }
 
    return;
}

/*---------------------------------------------------------------*/
/* converts an 8-bit gray code word to binary                    */
/*---------------------------------------------------------------*/
unsigned char  gray_to_bin(unsigned char gray)
{
    int i,j;
    unsigned char bit1,bit2,binary=0;

    binary = gray&(1<<7);

    for (i=6;i>=0;i--)
      {
	bit1 = ( (gray&(1<<i)) ? 1 : 0 );
	bit2 = ( (binary&(1<<(i+1))) ? 1 : 0);
	binary |= ( (bit1^bit2) ? (1<<i) : 0 );
      }
 
    return(binary);
}

/*---------------------------------------------------------------*/
/* flip bit order in an array of 8-bit words                     */
/*---------------------------------------------------------------*/
void flip_bits(unsigned char *words, int N)
{
  int i,j;
  unsigned char temp;

  for (i=0;i<N;i++)
    {
      for (j=0,temp=0;j<8;j++)
	  if ( (words[i]&(1<<j)) ) temp |= 128>>j;
      words[i] = temp;
    }
  return;
}

