/*-------------------------------------------------------------*/
/* PAT package driver program "self_test" */
/* Loops bitstreams into pattern FIFO and out of DAQ FOFO      */ 
/*-------------------------------------------------------------*/

#include <stdio.h>
#include "patt.h"
#include "io.h"
#include <unistd.h>
#include "camac_modules.h"

int main()
{
  long i,j,loop,N,badn=0,offs=1;
  unsigned char byte[9000],bit9[9000];
  unsigned char expect[14]={1,2,4,8,0,0,1,3,7,15,15,15,0,0};
  long fail[20]={0};
  char name[10];

/******************************/
/* Begin Initialization Phase */
/******************************/

/*initialize patt package*/
  patt_reset();

/*select directory with pattern files*/
  set_path("./");

/*load file with channel definitions*/
  chn_load("scrambler");

/*******************************/
/* END OF INITIALIZATOIN PHASE */
/*******************************/

/* load test pattern */
  addpat("self_test3");

  printf("\n Ready to go. Enter times to loop:\n ");
  scanf("%d",&loop);
  if (loop==1) bit9select(0);
  else bit9select(1);
  out_dump();

  for (i=0;i<loop;i++)
    {      
      /*      set_pattern_time(400);*/
      out_run();

/* read input register */
      N = inreg_read_fifo( byte, bit9 );

/* compare data to standard */
      if (i) printf("N=%d\n",N);
      if ( (N-12) ) badn++;
      for (j=0;j<12;j++)
	{
	  byte[j] &= 15;
	  if (i) printf("line %0d = %00d/%d\n",j,byte[j],bit9[j]);
	  if (j<14) if ( ( byte[j] - expect[j]) ) fail[j]++;
	}
    }

/* print results */
  printf(" Number of words failed %d times.\n",badn);
  for (j=0;j<15;j++)
    printf(" line %d failed %d times.\n",j,fail[j]);
  return(0);
}
