#ifndef CAMAC_MODULES_H
#define CAMAC_MODULES_H

/*---------------------------------------------------------------------------*/
/*                        MODULES      PACKAGE                               */
/*                                                                           */
/*      camac_modules.h:     globals and function prototypes.                */
/*---------------------------------------------------------------------------*/



/* Function Prototypes: */
/*----------------------*/

/* adc.c -- read LeCroy 2232 channel in millivolts */
void  adc_address(int slot);
short adc_read(short channel);

/* dac02.c -- DAC utils for CIO-DAC02/16 board */
int dac02_set(int dac_number, float volts);
int dac02_set_port(int dac_number, unsigned long ival);

/* dac.c -- DAC interface routine */
void dac_address(int slot);
int dac_set(double volt);

/* dac10.c -- Kinetic Systems 3110 DAC interface routine */
void dac10_address(int slot);
int dac10_set(int output, double volt);
 
/* inreg.c -- input register routines */
void inreg_address(int slot);
int inreg_read_fifo(unsigned char *array, unsigned char *bit8);

/* outreg.c -- output register interface routines */
void outreg_address(int slot, int subad);
void outreg0_address(int slot, int subad);
/* void outreg(unsigned long subad, unsigned long *data, int nwords); */
/* void outreg_0(int n_on, int *on, int n_off, int *off); */
/* int outreg0_whatis(int bit); */
/* unsigned long outreg0_getstate(void); */

#endif /* CAMAC_MODULES_H */
