#ifndef HBOOK_H
#define HBOOK_H

/************************************************************************/
/*                                                                      */
/*                           hbook.h                                    */
/*                                                                      */
/* Include this file to use HBOOK from a c program                      */
/*                                                                      */
/* include <stdio.h> is needed for strlen                               */
/* To link must include libraries -lftn and -lm                         */
/************************************************************************/

struct { int paw[500000]; } pawc_;

static void hlimit(int size)
{
  hlimit_(&size);
}

static int hropen(int unit, char *rzdir, char *fname, char *opt, int recl)
{
  int ierr;
  hropen_(&unit, rzdir, fname, opt, &recl, &ierr,\
	  strlen(rzdir), strlen(fname), strlen(opt));
  return ierr;
}

static void \
hbook1(int hid, char *name, int bins, float min, float max, float vmx)
{
  hbook1_(&hid, name, &bins, &min, &max, &vmx, strlen(name));
}

static void hbook2(int hid, char *name, int binsx, float xmin, float xmax,\
		   int binsy, float ymin, float ymax, float vmx)
{
  hbook2_(&hid, name, &binsx, &xmin, &xmax, \
	              &binsy, &ymin, &ymax, &vmx, strlen(name));
}

static void hbprof(int hid, char *name, int bins,\
		   float xmin, float xmax, float ymin, float ymax, char *opt)
{
  hbprof_(&hid, name, &bins, &xmin, &xmax, &ymin, &ymax, opt,\
	  strlen(name),strlen(opt));
}

static void hbookn(int hid, char *name, int nvar, char *file, int nwords,\
		   char *tags, int tag_length)
{
  hbookn_(&hid, name, &nvar, file, &nwords, tags, strlen(name), \
          strlen(file), tag_length);
}

static void hfill(int hid, float x, float y, float wgt)
{
  hfill_(&hid, &x, &y, &wgt);
}

static int hrout(int hid)
{
  int icycle = 0;
  hrout_(&hid, &icycle, " ", 1);
  return icycle;
}

static void hrend(char *dir)
{
  hrend_(dir, strlen(dir));
}

static void hbnt(int hid, char *name, char *opt)
{
  hbnt_(&hid, name, opt, strlen(name), strlen(opt));
}

static void hbname(int hid, char *blkname, void *addr, char *names)
{
  hbname_(&hid, blkname, addr, names, strlen(blkname), strlen(names));
}

#endif /* HBOOK_H */
