
#include <stdio.h>
#include <math.h>
#include <limits.h>
#include "camac_sjc.h"
#include "camac_modules.h"


/* read voltage in one DVM channel */
double dvm_read(short channel)
{
        typedef unsigned char UC;
	int fd,exp,qres,stat,loop;
	unsigned long data[2]={0,0};
	short out[2]={0,0};
	unsigned char *f;
	double volt,sign;

/* Open Camac controller */
/*
	camac_open(&fd);
*/

/* set number of channel to be read */
	loop = 10;
	do {
	  do {
	    data[0]=channel-1;
	    stat=camac_cmd(17,0,17,1,1,data,&qres);
	  } while( ( (!qres) || stat ) && loop-- );  
	
/* read channel voltage */
	  stat=camac_cmd(17,0,0,1,1,data,&qres);
	  out[0]=data[0];
	} while( ( (!qres) || stat ) && loop-- );  

/* convert DVM data from VAX real format to standard */
	f=(unsigned char *)out;
	sign=((f[0] & 0x80) ? (-1.) : (1.));
	exp=((UC)(f[0]<<1))+((f[1] & 0x80) ? 1 : 0) - 129;
	volt=1.+(double)((UC)(f[1]<<1))/256.;
	volt*=(sign*pow(2.,(double)exp));
/*
	camac_close(fd);
*/
	return(volt);
}

/* initialize DVM--need only call once */
void dvm_init(void)
{
	int fd,qres;
	unsigned long data[2]={0,0};

        printf("Initializing voltmeter: 10 sec patience please...\n");

/* initialize DVM; must wait 6-7 secs. afterwards, using 8 for safety */
/*
	camac_open(&fd);
*/
	camac_cmd(17,0,9,1,1,data,&qres); 
	sginap(800);
/* set data format to VAX real */
	camac_cmd(17,0,16,1,1,data,&qres);
/*
	camac_close(fd);
*/
	return;
}
